/*  compatibility.pl, v 1.0 Feabhra 11, 1993 by Dave Sherratt

    Modified (M) 1993 Dave Sherratt.

    Purpose: compatibility with Prolog in the Edinburgh/Quintus tradition.
*/

:- module($compatibility,
	[ (public)/1
	, (mode)/1
	, is_Prolog/1
	, numbervars/3
	, prolog_flag/2
	, prolog_flag/3
	, ve/1
	, vere/1
	]).


:- op( 1150 , fx , [ (public) , (mode) ] ) .

:- op( 400 , yfx , div ) .

public _ .

mode _ .


is_Prolog( 'SWI-Prolog' ) .


% numbervars/3

numbervars( F , N0 , N ) :-
  numbervars( F , '$VAR' , N0 , N ) .


% prolog_flag/2

prolog_flag( Flag , Value ) :- please( Flag , Value , Value ) .


% prolog_flag/3

prolog_flag( Flag , Old , New ) :- please( Flag , Old , New ) .



:- op( 900 , fy , [ ve , vere ] ) .

ve File :-
  name( File , FileCharList ) ,
  '$ve'( FileCharList , 0 ) .

vere File :-
  name( File , FileCharList ) ,
  '$ve'( FileCharList , 1 ) .

'$ve'( FileCharList , Recons ) :-
  VEditorCharList = "jet" ,
  '$give_command'(
    [ VEditorCharList , "-title" , FileCharList , FileCharList ]
  , Status
  ) ,
  ( ( Recons = 0 ; Status =\= 0 ) ->
    true
  ; name( File , FileCharList ) ,
    consult( File )
  )  .

'$give_command'( Words , Status ) :-
  '$build_command'( Words , Command ) ,
  name( A_Command , Command ) ,
  ( shell( A_Command ) -> Status = 0 ; Status = 256 ) .

'$build_command'( [ Word | Words ] , Command ) :-
  '$build_command'( Words , Command_Tail ) ,
  append( Word , [ 0'  | Command_Tail ] , Command ) .
'$build_command'( [] , [] ) .
